unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, IniFiles,
  StdCtrls, Buttons, ExtCtrls, ShellApi;

type
  TMain = class(TForm)
    Edit1: TEdit;
    OpenDialog1: TOpenDialog;
    BitBtn1: TBitBtn;
    Edit2: TEdit;
    BitBtn2: TBitBtn;
    Edit3: TEdit;
    BitBtn3: TBitBtn;
    Edit4: TEdit;
    BitBtn4: TBitBtn;
    ComboBox: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    Shape1: TShape;
    Bevel3: TBevel;
    Label_1: TLabel;
    Label_2: TLabel;
    Label_3: TLabel;
    Label_4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ComboBoxChange(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Label3Click(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure Edit4KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    ApriFile: TIniFile;
	 procedure LeggiIni;

  public
    { Public declarations }
  end;

var
  Main: TMain;
  Estensione: string;

implementation

{$R *.DFM}

procedure TMain.LeggiIni;
begin
  ComboBox.Clear;
  Edit1.Text := '';
  Edit2.Text := '';
  Edit3.Text := '';
  Edit4.Text := '';

  ApriFile := TIniFile.Create(UpperCase(ExtractfilePath(application.exename)) + 'APRI.INI');
  ApriFile.ReadSections(ComboBox.Items);
end;

procedure TMain.FormCreate(Sender: TObject);
begin
	LeggiIni;
end;

procedure TMain.ComboBoxChange(Sender: TObject);
begin
	Edit1.OnChange := nil;
	Edit2.OnChange := nil;
	Edit3.OnChange := nil;
	Edit4.OnChange := nil;
   Estensione := ComboBox.Text;

   Edit1.Text := ApriFile.ReadString(Estensione, 'Primo', '');
   Edit2.Text := ApriFile.ReadString(Estensione, 'Secondo', '');
   Edit3.Text := ApriFile.ReadString(Estensione, 'Terzo', '');
   Edit4.Text := ApriFile.ReadString(Estensione, 'Quarto', '');

   Label_1.Caption := ApriFile.ReadString(Estensione, 'PrimoNome', '');
   Label_2.Caption := ApriFile.ReadString(Estensione, 'SecondoNome', '');
   Label_3.Caption := ApriFile.ReadString(Estensione, 'TerzoNome', '');
   Label_4.Caption := ApriFile.ReadString(Estensione, 'QuartoNome', '');

	Edit1.OnChange := Edit1Change;
	Edit2.OnChange := Edit1Change;
	Edit3.OnChange := Edit1Change;
	Edit4.OnChange := Edit1Change;
end;

procedure TMain.BitBtn1Click(Sender: TObject);
var app: string;
begin
	if ComboBox.Text = '' then exit;

	OpenDialog1.Execute;
   app := OpenDialog1.FileName;
   if app <> '' then
   begin
   	Edit1.Text := app;
		app := InputBox('Enter the Application Description', 'Description:', '');
      if app <> '' then
      	Label_1.Caption := app
      else
      	Label_1.Caption := ExtractFileName(Edit1.Text);
   end;
end;

procedure TMain.BitBtn2Click(Sender: TObject);
var app: string;
begin
	if ComboBox.Text = '' then exit;

	OpenDialog1.Execute;
   app := OpenDialog1.FileName;
   if app <> '' then
   begin
   	Edit2.Text := app;
		app := InputBox('Enter the Application Description', 'Description:', '');
      if app <> '' then
      	Label_2.Caption := app
      else
      	Label_2.Caption := ExtractFileName(Edit2.Text);
   end;
end;

procedure TMain.BitBtn3Click(Sender: TObject);
var app: string;
begin
	if ComboBox.Text = '' then exit;

	OpenDialog1.Execute;
   app := OpenDialog1.FileName;
   if app <> '' then
   begin
   	Edit3.Text := app;
		app := InputBox('Enter the Application Description', 'Description:', '');
      if app <> '' then
      	Label_3.Caption := app
      else
      	Label_3.Caption := ExtractFileName(Edit3.Text);
   end;
end;

procedure TMain.BitBtn4Click(Sender: TObject);
var app: string;
begin
	if ComboBox.Text = '' then exit;

	OpenDialog1.Execute;
   app := OpenDialog1.FileName;
   if app <> '' then
   begin
   	Edit4.Text := app;
		app := InputBox('Enter the Application Description', 'Description:', '');
      if app <> '' then
      	Label_4.Caption := app
      else
      	Label_4.Caption := ExtractFileName(Edit4.Text);
   end;
end;

procedure TMain.BitBtn5Click(Sender: TObject);
begin
   ApriFile.WriteString(Estensione, 'Primo', Edit1.Text);
   ApriFile.WriteString(Estensione, 'Secondo', Edit2.Text);
   ApriFile.WriteString(Estensione, 'Terzo', Edit3.Text);
   ApriFile.WriteString(Estensione, 'Quarto', Edit4.Text);

   ApriFile.WriteString(Estensione, 'PrimoNome', Label_1.Caption);
   ApriFile.WriteString(Estensione, 'SecondoNome', Label_2.Caption);
   ApriFile.WriteString(Estensione, 'TerzoNome', Label_3.Caption);
   ApriFile.WriteString(Estensione, 'QuartoNome', Label_4.Caption);
	Shape1.Brush.Color := clGreen;
end;

procedure TMain.BitBtn6Click(Sender: TObject);
var app: string;
begin
	app := InputBox('Registering a new extension', 'Extension:', '');
   if app = '' then exit;

   app := '.' + app;

   if ComboBox.Items.IndexOf(app) <> -1 then
   begin
   	MessageDlg('Extension is already registered', mtWarning, [mbOk],0);
		exit;
	end;

   ApriFile.WriteString(app, 'Primo', '');
   ApriFile.WriteString(app, 'Secondo', '');
   ApriFile.WriteString(app, 'Terzo', '');
   ApriFile.WriteString(app, 'Quarto', '');
   LeggiIni;
end;

procedure TMain.BitBtn7Click(Sender: TObject);
begin
	if ComboBox.Text = '' then exit;
   If MessageDlg('Are you sure?', mtWarning, [mbYES,mbNO], 0) = ID_NO Then Exit;

	ApriFile.EraseSection(ComboBox.Text);
   ComboBox.Text := '';
	LeggiIni;
end;

procedure TMain.BitBtn8Click(Sender: TObject);
begin
	ComboBoxChange(Self);
	Shape1.Brush.Color := clGreen;
end;

procedure TMain.Edit1Change(Sender: TObject);
begin
	Shape1.Brush.Color := clYellow;
end;

procedure TMain.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
	if key = chr(VK_BACK) then
   begin
   	Edit1.Text := '';
	   Label_1.Caption := '';
   end;
end;

procedure TMain.Label3Click(Sender: TObject);
begin
	ShellExecute(Application.handle,'Open',Pchar('mailto:gfedele@gruppoas.it'),'','',SW_SHOW);
end;

procedure TMain.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
	if key = chr(VK_BACK) then
   begin
   	Edit2.Text := '';
	   Label_2.Caption := '';
   end;
end;

procedure TMain.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
	if key = chr(VK_BACK) then
   begin
   	Edit3.Text := '';
	   Label_3.Caption := '';
   end;
end;

procedure TMain.Edit4KeyPress(Sender: TObject; var Key: Char);
begin
	if key = chr(VK_BACK) then
   begin
   	Edit4.Text := '';
	   Label_4.Caption := '';
   end;
end;

end.
